# Font-lock support of message bodies was added (Source1) from 
# http://de.geocities.com/ulf_jasper/emacs.html on 10th February 2007.
#
# In order to make the PGP stuff work with GNU Emacs <22, I have pulled pgp*.el
# from the GNU Emacs CVS - see Source11-16. These were pulled from CVS on 21st
# June 2007.

# Upstream used rather odd versioning: there is a version number, and then a
# "devo" number which is the BZR tree revision, separated with a hypen. However,
# rpm doesn't allow a hyphen in the versoion number.
%define vmversion 8.0.3
%define devoversion 495

%define pkgdir %{_datadir}/emacs/site-lisp/vm
%define pixmapdir %{pkgdir}/pixmaps
%define startd %{_datadir}/emacs/site-lisp/site-start.d/
%define initfile %{startd}/vm-mode-init.el

Summary: Emacs VM mailreader
Name: emacs-vm
Version: %{vmversion}.%{devoversion}
Release: 3%{?dist}
License: GPLv2+
Group: Applications/Internet
URL: http://www.nongnu.org/viewmail/

Source0: http://download.savannah.nongnu.org/releases/viewmail/vm-%{vmversion}-%{devoversion}.tgz 
Source1: u-vm-color.el
Source11: pgg.el
Source12: pgg-def.el
Source13: pgg-gpg.el
Source14: pgg-parse.el
Source15: pgg-pgp.el
Source16: pgg-pgp5.el
Patch0: makefile-add-extra-lisp.patch
Patch1: vm-8.0.3-emacs21-fix-Makefile.patch

Requires: emacs
Requires(pre): /sbin/install-info 
Requires(post): /sbin/install-info 
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: emacs texinfo texinfo-tex

%description
VM (View Mail) is an Emacs subsystem that allows UNIX mail to be read
and disposed of within Emacs.  Commands exist to do the normal things
expected of a mail user agent, such as generating replies, saving
messages to folders, deleting messages and so on.  There are other
more advanced commands that do tasks like bursting and creating
digests, message forwarding, and organizing message presentation
according to various criteria. 

%package el
Group: Applications/Internet
Summary: Elisp source files for VM mailreader for emacs
Requires: %{name} = %{version}-%{release}

%description el 
The %{name}-el package contains the elisp source files for the %{name}
package. It is not necessary to install this if you want to run vm.

%prep
%setup -q -n vm-%{vmversion}-%{devoversion}

# Add extra elisp source files and modify Makefile.in so they get compiled
cp %{SOURCE1} lisp
cp %{SOURCE11} lisp
cp %{SOURCE12} lisp
cp %{SOURCE13} lisp
cp %{SOURCE14} lisp
cp %{SOURCE15} lisp
cp %{SOURCE16} lisp
%patch0

# Fix build issue specific to using Emacs 21 to build 8.0.3
%patch1

%build
export CFLAGS="$RPM_OPT_FLAGS"
%configure
make

%install
rm -rf %{buildroot}

install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_infodir}

make install \
  prefix=%{buildroot}%{_prefix} \
  bindir=%{buildroot}%{_bindir} \
  info_dir=%{buildroot}%{_infodir} \
  pixmapdir=%{buildroot}%{pixmapdir}

# Copy source lisp files into buildroot for emacs-vm-el sub-package
(cd lisp ; install -m 644 *.el %{buildroot}%{pkgdir})

# Create initialization file.
install -d %{buildroot}/%{startd}
cat > %{buildroot}/%{initfile} <<EOF
;; Startup settings for VM
(setq vm-toolbar-pixmap-directory "%{pixmapdir}")
(setq vm-image-directory "%{pixmapdir}")
(require 'vm-autoloads)

;; Settings for u-vm-color.el 
(require 'u-vm-color)
(add-hook 'vm-summary-mode-hook 'u-vm-color-summary-mode)
(add-hook 'vm-select-message-hook 'u-vm-color-fontify-buffer)

(defadvice vm-fill-paragraphs-containing-long-lines
    (after u-vm-color activate)
    (u-vm-color-fontify-buffer))
EOF

%clean
rm -rf %{buildroot}

%post 
/sbin/install-info %{_infodir}/vm.info.gz %{_infodir}/dir 2>/dev/null || :

%preun
if [ "$1" = "0" ] ; then 
 /sbin/install-info --delete %{_infodir}/vm.info.gz %{_infodir}/dir 2>/dev/null || :
fi

%files
%defattr(-,root,root,-)
%doc README COPYING
%doc %{_infodir}/*
%{_bindir}/*
%{pixmapdir}
%{pkgdir}/*.elc
%{initfile}
%dir %{pkgdir}

%files el
%defattr(-,root,root,-)
%{pkgdir}/*.el

%changelog
* Thu Aug 30 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.3.495-3
- Fix problem with vm-autoloads.el RH BZ #262361 

* Wed Aug 22 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.3.495-2
- Add patch to fix building 8.0.3 with Emacs 21 rather than the hack
- Add back in the extra lisp files once more

* Wed Aug 22 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.3.495-1.3
- Fix bug with vm-cus-load.el not being gnerated, second attempt

* Wed Aug 22 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.3.495-1.2
- Fix bug with vm-cus-load.el not being gnerated

* Tue Aug 21 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.3.495-1.1
- Comment out byte compilation of additional files to see if that fixes build
  issues 
- Add BuildRequires: texinfo-tex to build pdf docs

* Tue Aug 21 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.3.495-1
- Update to version 8.0.3

* Mon Aug  6 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.2.482-4
- Fix archive directory name 

* Mon Aug  6 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.2.482-3
- Fix pixmap installation directory

* Sun Aug  5 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.2.482-2
- Correct previous changelog entry
- Correct error in source .tgz filename

* Sun Aug  5 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.2.482-1
- Update to 8.0.2-devo482
- Clarify license

* Thu Jun 28 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.1.465-1
- Update to bugfix release 8.0.1 (fixes BZ #245780)

* Wed Jun 27 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.0.453-2.1
- Fix typo

* Tue Jun 26 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.0.453-2
- Ensure all files in /usr/bin have exec bit set (BZ #245740)
- Correct a date of the pgg*.el CVS checkout in the comments
- Fix changelog typo

* Tue Jun 19 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 8.0.0.453-1
- Update to version 8.0.0 devo 453 which removes the need for the vmrf patch
- No longer need to bundle vcard stuff as that is included upstream
- Spec file cleanups
- No longer use separate pixmaps

* Sun Mar 18 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 7.19.%{vmrfversion}-9
- Bump release to fix problem with CVS sources file

* Sun Mar 18 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 7.19.devo282-8
- Redefine version to include vmrf patch version (devo282)
- Remove pointless %%{pkg} macro
- Add new pixmaps with better sizing (still ugly though)
- Renamed the vmrf patch to include the version

* Sat Feb 10 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 7.19-7
- Added pgg*.el from Emacs 22 CVS
- Added u-vm-color.el from http://de.geocities.com/ulf_jasper/emacs.html
- Added vcard support from http://www.splode.com/users/friedman/software/emacs-lisp/
- Fixed name of info files in pre and post scripts

* Sat Feb  3 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 7.19-5
- Add patch from http://www.robf.de/Hacking/elisp/ (resolves bug 224501)
- Ensure CFLAGS="$RPM_OPT_FLAGS" (bug 225101)

* Mon Aug 28 2006 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 7.19-4
- Bump release for FC-6 mass rebuild

* Tue Jun 20 2006 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 7.19-3
- Change group to Applications/Internet
- Add release tag to the Requires for the -el package

* Tue May 23 2006 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 7.19-2
- Clean up spec file

* Fri Sep  2 2005 Jonathan Underwood <jonathan.underwood@gmail.com> - 7.19-1.fc4.jgu
- Initial build
- Generate vm-mode-init.el
- Separate out *.el files into -el package
- Added patch to remove warnings in the decode and encode programs
